#!/usr/bin/ruby

require 'fileutils'

class RTVProg
  
  def initialize
    @dir = File::dirname(__FILE__)
    conf_path = File.expand_path("rtvbook.conf", @dir)
    @conf_dir = File::dirname(conf_path)
    eval(File::open(conf_path) {|f| f.read }.untaint)

    cache_dir_path = File.expand_path('cache', @dir)
    @cache_dir = cache_dir_path

    @rec_data_dir ||= ""
    @tvbook_pl_path ||= ""
    @rec_reserving_time ||= 24 * 60
  end

  def rec_reserve_from_cache_files
    reserve_time = Time.now + @rec_reserving_time.to_i * 60
    nowdir = Dir::pwd
    cache_files = Dir::entries(@cache_dir)
    cache_files.each do |c_file|
      if c_file.length > 13 then
        c_filetime = Time.local(c_file.slice(0..3).to_i,
                                c_file.slice(4..5).to_i,
                                c_file.slice(6..7).to_i,
                                c_file.slice(9..10).to_i,
                                c_file.slice(11..12).to_i, 0)
        if c_filetime < reserve_time then
          c_filepath = File.expand_path(c_file, @cache_dir)
          Dir::chdir(@rec_data_dir)
          result = system("nkf --unix #{c_filepath} | #{@tvbook_pl_path} 2>/dev/null")
          Dir::chdir(nowdir)
          if result == true then
            print "rtvprog.rb: tv rec scheduled #{c_file}\n"
          else
            print "rtvprog.rb: tv rec scheduling missed #{c_file}\n"
          end
        end
      end
    end
  end

end #RTVProg
